'Marcin Wizania

$noramclear
$crystal = 2000000
Config Watchdog = 2048
Stop Watchdog

Config Portb = Output
Config Pind.2 = Input
Config Pind.3 = Input
Config Pind.5 = Input
Config Pind.6 = Input

Declare Sub Wyswietl(cyf1 As Byte , Cyf2 As Byte , Cyf3 As Byte , Cyf4 As Byte)
Declare Sub Ustaw(temp As Byte)
Declare Sub Licz
Declare Sub Konwert(zm1 As Byte , Zm2 As Byte)
On Int0 Zlicz
On Int1 Wybierz

Dim Flaga1 As Bit
Dim Temp As Byte
Dim Cyf1 As Byte
Dim Cyf2 As Byte
Dim Cyf3 As Byte
Dim Cyf4 As Byte
Dim Kilometr1 As Byte
Dim Kilometr2 As Byte
Dim Temp1 As Byte
Dim Zm_pomoc As Byte
Dim Dlug_krok1 As Byte
Dim Zm1 As Byte
Dim Zm2 As Byte
Dim Dlug_krok2 As Byte
Dim Temp2 As Byte
Dim Metry1 As Byte
Dim Odlicz As Word

Cs1 Alias Portb.1
Da2 Alias Portb.2
Da1 Alias Portb.3
B3 Alias Portb.4
B2 Alias Portb.5
B1 Alias Portb.6
B0 Alias Portb.7
S2 Alias Pind.3
S3 Alias Pind.5
S4 Alias Pind.6

Set Portd.3
Set Portd.5
Set Portd.6
Set Portd.2

Cyf1 = 15
Cyf2 = 15
Cyf3 = 15
Flaga1 = 0
Odlicz = 0

Readeeprom Dlug_krok1 , 2                                   'odczyt stalych zapisanych w eepromie
Readeeprom Kilometr1 , 10
Readeeprom Kilometr2 , 11
Readeeprom Metry1 , 12
Readeeprom Zm_pomoc , 13


If Dlug_krok1 < 20 Or Dlug_krok1 > 200 Then                 'przypisanie odpowiednich wartosci zmienny podczas
   Dlug_krok1 = 100                                         'pierwszego uruchamiania programu
End If
If S3 = 0 And S4 = 0 Then                                   'jezeli przycisk S4 i S3 nacisniete to przejdz do instrukcji ustawiajacych
   Cyf4 = 14                                                'dlugosc kroku
   Call Wyswietl(cyf1 , Cyf2 , Cyf3 , Cyf4)                 'wyswietl dlugosc w cm
   Wait 1
   Do
   Loop Until S3 = 1 And S4 = 1
   Do
     Dlug_krok2 = Dlug_krok1 / 100
     Temp2 = Dlug_krok1 Mod 100
     Call Konwert(temp2 , Dlug_krok2)                       'podprogram konwersji liczby na kod wyswietlacza LCD
     Call Wyswietl(cyf1 , Cyf2 , Cyf3 , Cyf4)
     If S4 = 0 Then                                         'Instrukcje zwiekszania dlugosci kroku
        Incr Dlug_krok1
        If Dlug_krok1 = 201 Then
           Dlug_krok1 = 200
        End If
     End If
     If S3 = 0 Then                                         'Instrukcje zmniejszania dlugosci kroku
        Decr Dlug_krok1
        If Dlug_krok1 = 19 Then
           Dlug_krok1 = 20
        End If
     End If
     Waitms 200
   Loop Until S2 = 0                                        'Jezeli nacisniety zostanie przycisk S2 to wyjdz
   Cyf1 = 15                                                'z procedury ustawiania dlugosci kroku
   Cyf2 = 15
   Cyf3 = 15
   Cyf4 = 11
   Call Wyswietl(cyf1 , Cyf2 , Cyf3 , Cyf4)
   Writeeeprom Dlug_krok1 , 2                               'zapamietanie wprowadzonej dlugosci kroku
   Wait 1
End If

Enable Interrupts
Enable Int0
Enable Int1

Do
  Incr Odlicz
  If S3 = 0 Then                                            'Jezeli S3 zostanie przycisniety na dluzej niz 2 sekundy to zerowane
    Wait 2                                                  'jest licznik
    If S3 = 0 Then
      Kilometr1 = 0
      Kilometr2 = 0
      Zm_pomoc = 0
      Metry1 = 0
    End If
  End If
  If Flaga1 = 1 Then                                        'odpowiednia konwersja wyswietlanych danych wzaleznosci od flagi flaga1
    Call Konwert(kilometr1 , Kilometr2)
  Else
    Call Konwert(metry1 , Kilometr1)
  End If
  Call Wyswietl(cyf1 , Cyf2 , Cyf3 , Cyf4)
  If Odlicz => 2500 Then
    Idle
  End If
Loop
End

Sub Konwert(zm1 As Byte , Zm2 As Byte)                      'procedura konwersji zmiennych na
  Temp1 = Makebcd(zm1)                                      'poprawna wartosc wyswietlana przez LCD
  Cyf1 = Temp1
  Rotate Temp1 , Right , 4
  Cyf2 = Temp1
  Temp1 = Makebcd(zm2)
  Cyf3 = Temp1
  Rotate Temp1 , Right , 4
  Cyf4 = Temp1
End Sub

Sub Wyswietl(cyf1 As Byte , Cyf2 As Byte , Cyf3 As Byte Byte , Cyf4 As Byte)       'wyswietlanie czterech cyfr
  Cyf1 = Cyf1 And &B00001111
  Cyf2 = Cyf2 And &B00001111
  Cyf3 = Cyf3 And &B00001111
  Cyf4 = Cyf4 And &B00001111
  If Cyf4 = 0 Then
    Cyf4 = 15
    If Cyf3 = 0 Then
      Cyf3 = 15
      If Cyf2 = 0 Then
        Cyf2 = 15
      End If
    End If
  End If
  Set Da1
  Set Da2
  Call Ustaw(cyf1)
  Reset Da1
  Call Ustaw(cyf2)
  Set Da1
  Reset Da2
  Call Ustaw(cyf3)
  Reset Da1
  Call Ustaw(cyf4)
End Sub

Sub Ustaw(temp As Byte)                                     'procedura ustawia odpowiednia pozycje cyfry oraz wczytuje do niej wartosc
  Reset Cs1                                                 'przeznaczona do wyswietlenia
  If Temp.0 = 1 Then
    Set B0
  Else
    Reset B0
  End If
  If Temp.1 = 1 Then
    Set B1
  Else
    Reset B1
  End If
  If Temp.2 = 1 Then
    Set B2
  Else
    Reset B2
  End If
  If Temp.3 = 1 Then
    Set B3
  Else
    Reset B3
  End If
  Waitms 1
  Set Cs1
  Waitms 1
End Sub

Zlicz:
  Decr Odlicz                                               'procedura obslugi przerwania wywolywanego przez dolaczony czujnik
  Waitms 50
  Disable Int0
  Zm_pomoc = Zm_pomoc + Dlug_krok1                          'do zmiennej zm_pomoc dodawaj zapamietana dlugosc kroku
  If Zm_pomoc => 100 Then                                   'jezeli zmienna ta wieksza od 100 to zliczony zostal 1 metr
    Incr Metry1                                             'zwiekszlicznik metrow
    Zm_pomoc = Zm_pomoc - 100                               'odejmij odpowiednia wartosc od zmiennej zm_pomoc
    If Zm_pomoc => 100 Then
      Zm_pomoc = Zm_pomoc - 100
      Incr Metry1
    End If
    If Metry1 = 100 Then                                    'jezeli licznik metrow osiagnie wartosc 100 to zwieksz
      Metry1 = 0                                            'wartosc zmiennej kilometr1
      Incr Kilometr1
      If Kilometr1 = 100 Then                               'jezeli zmienna kilometr1 =100 to wyzeruj ja i zwieksz zmienna kilometr2
        Incr Kilometr2
        Kilometr1 = 0
        If Kilometr2 = 100 Then                             'jezeli wartosc osiagnie gorna granice zliczonich kilometrow 9999kilometrow
          Kilometr2 = 99                                    'to zatrzymaj zliczanie kilometrow
          Kilometr1 = 99
        End If
      End If
    End If
  End If
  Writeeeprom Kilometr1 , 10                                'zapisz zmierzone wartosci dlugosci
  Writeeeprom Kilometr2 , 11
  Writeeeprom Metry1 , 12
  Writeeeprom Zm_pomoc , 13
  Do
  Loop Until Pind.2 = 1
  Waitms 50
  Enable Int0
Return

Wybierz:                                                    'Jezeli nacisniety zostal S2 to zmien tryb wyswietlania
  Flaga1 = Not Flaga1                                       'kilometry lub metry
  If Flaga1 = 1 Then
    Cyf1 = 15
    Cyf2 = 15
    Cyf3 = 15
    Cyf4 = 12
  Else
    Cyf1 = 15
    Cyf2 = 15
    Cyf3 = 15
    Cyf4 = 13
 End If
 Call Wyswietl(cyf1 , Cyf2 , Cyf3 , Cyf4)
 Wait 1
 Odlicz = 0
Return