'Kolko i krzyzyk
'Marcin Wizania

$noramclear
$crystal = 8000000
Config Watchdog = 2048
Stop Watchdog

Config Timer0 = Timer , Prescale = 8
Config Portb = Output
Config Pind.0 = Output
Config Pind.1 = Output
Config Pind.6 = Output
Config Pind.2 = Input
Config Pind.3 = Input
Config Pind.4 = Input
Config Pind.5 = Input

On Timer0 Wyswietl
On Int0 Zalacz
Declare Sub Obs_klaw

Dim Tab(9) As Byte
Dim Key As Byte
Dim J As Byte
Dim I As Byte
Dim P As Byte
Dim Flaga1 As Bit
Dim Flaga3 As Bit
Dim Temp As Byte
Dim Flaga2 As Bit
Dim Licznik As Word
Dim Flaga4 As Bit
Dim K As Byte

W1 Alias Portd.6
W2 Alias Portd.0
W3 Alias Portd.1
Dr1 Alias Portb.2
Dg1 Alias Portb.3
Dr2 Alias Portb.4
Dg2 Alias Portb.5
Dr3 Alias Portb.6
Dg3 Alias Portb.7
S1 Alias Pind.3
S2 Alias Pind.4
S3 Alias Pind.5
Kol Alias Portb.1

Do
  For I = 1 To 9                                            'Petla kasujca elementy tablicy TAB
    Tab(i) = 0
  Next I
  J = 0
  Temp = 0
  If P = 1 Then
      P = 2
    Else
      P = 1
    End If
  Portb = 0
  Portd = 255
  Key = 0
  Reset Flaga4
  Reset W1
  Reset W2
  Reset W3
  Reset Flaga1
  Reset Flaga2
  Reset Flaga3
  Enable Interrupts
  Enable Int0
  Enable Timer0
  Start Timer0
  Do
    If Licznik => 60000 Then                                'Warunek wprowadzajcy mikrokontroler w tryb IDLE
      Disable Timer0
      Stop Timer0
      Portb = 0
      Reset W1
      Reset W2
      Reset W3
      Idle
    End If
    If Flaga4 = 0 Then                                      'Jezeli flaga4=0 to bsluguj klawiature matrycowa oraz
      Call Obs_klaw                                         'sprawdzaj waruneki zakonczenia gry
      For I = 1 To 2
        If Tab(1) = I Then
          If Tab(2) = I Then
            If Tab(3) = I Then
              Set Flaga2
            End If
          End If
        End If
        If Tab(2) = I Then
          If Tab(5) = I Then
            If Tab(8) = I Then
              Set Flaga2
            End If
          End If
        End If
        If Tab(4) = I Then
          If Tab(5) = I Then
            If Tab(6) = I Then
              Set Flaga2
            End If
          End If
        End If
        If Tab(7) = I Then
          If Tab(8) = I Then
            If Tab(9) = I Then
              Set Flaga2
            End If
          End If
        End If
        If Tab(1) = I Then
          If Tab(4) = I Then
            If Tab(7) = I Then
              Set Flaga2
            End If
          End If
        End If
        If Tab(3) = I Then
          If Tab(6) = I Then
            If Tab(9) = I Then
              Set Flaga2
            End If
          End If
        End If
        If Tab(1) = I Then
          If Tab(5) = I Then
            If Tab(9) = I Then
              Set Flaga2                                    'Jezeli waruneg wygrania spelniony to ustaw flage2
            End If
          End If
        End If
        If Tab(3) = I Then
          If Tab(5) = I Then
            If Tab(7) = I Then
              Set Flaga2
            End If
          End If
        End If
        If Flaga2 = 1 Then                                  'Jezeli flaga2 ustawiona to zeruj flage4 oraz wygeneruj dzwiek zwyciestwa
          P = I
          Set Flaga4
          For K = 50 To 250 Step 50
            Sound Portb.0 , 100 , K
          Next K
          Reset Flaga2
        End If
      Next I
    End If
  Loop Until Flaga3 = 1                                     'Jezeli flaga3 ustowiona zostala w przerwaniu od przycisku S10
Loop                                                        'to wyjdz z petli do-loop
End

Wyswietl:                                                   'Procedura realizujaca wyswietlanie zaznaczej oraz obslugujaca klawiature matrycowa
  Incr Licznik                                              'Zwieksz zmienna licznik okreslajaca stan kiey procesor ma przejsc w stan IDLE
  Portb = 0
  Set Kol
  If J = 1 Then                                             'przy zmiennych j 1..3 sprawdzaj klawiature
    Set W1
  End If
  If J = 2 Then
    Set W2
  End If
  If J = 3 Then
    Set W3
  End If
  If S1 = 0 Or S2 = 0 Or S3 = 0 Then                        'zapisz odczytana wartosc z klawiatury do zmiennej key
    Key = Pind And &B01111011
  End If
  Reset W1
  Reset W2
  Reset W3
  Incr J
  If J = 11 Then                                            'Jezeli j=11 to zmien na j=1
    J = 1
  End If
  If J = 1 Then                                             'wyswietl punkt tab(1)
    If Tab(1) = 1 Then                                      'wartosc Zapisywana Do Tablicy Oznacza :1 - swieci led czerwona,
      Set W1 : Set Dr1                                      '2 - swieci led zielona
    End If
    If Tab(1) = 2 Then
      Set W1 : Set Dg1
    End If
  End If
  If J = 2 Then
    If Tab(2) = 1 Then
      Set W2 : Set Dr1
    End If
    If Tab(2) = 2 Then
      Set W2 : Set Dg1
    End If
  End If
  If J = 3 Then
    If Tab(3) = 1 Then
      Set W3 : Set Dr1
    End If
    If Tab(3) = 2 Then
      Set W3 : Set Dg1
    End If
  End If
  If J = 4 Then
    If Tab(4) = 1 Then
      Set W1 : Set Dr2
    End If
    If Tab(4) = 2 Then
      Set W1 : Set Dg2
    End If
  End If
  If J = 5 Then
    If Tab(5) = 1 Then
      Set W2 : Set Dr2
    End If
    If Tab(5) = 2 Then
      Set W2 : Set Dg2
    End If
  End If
  If J = 6 Then
    If Tab(6) = 1 Then
      Set W3 : Set Dr2
    End If
    If Tab(6) = 2 Then
      Set W3 : Set Dg2
    End If
  End If
  If J = 7 Then
    If Tab(7) = 1 Then
      Set W1 : Set Dr3
    End If
    If Tab(7) = 2 Then
      Set W1 : Set Dg3
    End If
  End If
  If J = 8 Then
    If Tab(8) = 1 Then
      Set W2 : Set Dr3
    End If
    If Tab(8) = 2 Then
      Set W2 : Set Dg3
    End If
  End If
  If J = 9 Then
    If Tab(9) = 1 Then
      Set W3 : Set Dr3
    End If
    If Tab(9) = 2 Then
      Set W3 : Set Dg3
    End If
  End If
  If J = 10 Then
    If P = 1 Then                                           'Wartosc P okresla ktorego przeciwnika dotyczy kolejka gry
      Set W3
      Reset W2
      Reset W1
    Else
      Set W2
      Reset W1
      Reset W3
    End If
    Reset Kol
  End If
Return

Sub Obs_klaw                                                'obsluga wartosci jaka zawiera zmienna key
  If Key = 104 Then                                         'wartosc 104 oznacza nacisniecie klawisza numer 2
    Temp = 2
  End If
  If Key = 112 Then
    Temp = 3
  End If
  If Key = 88 Then
    Temp = 1
  End If
  If Key = 26 Then
    Temp = 7
  End If
  If Key = 50 Then
    Temp = 9
  End If
  If Key = 42 Then
    Temp = 8
  End If
  If Key = 25 Then
    Temp = 4
  End If
  If Key = 49 Then
    Temp = 6
  End If
  If Key = 41 Then
    Temp = 5
  End If
  If Temp <> 0 Then
    If Tab(temp) = 0 Then
      Licznik = 0
      Sound Portb.0 , 100 , 1000                            'Wydaje dzwiek po kazdym nacisnieciu przycisku
      Tab(temp) = P
      Flaga1 = 1
    End If
    Temp = 0
  End If
  If Flaga1 = 1 Then                                        'Jezeli flaga1 ustawiona to zmien przeciwnika na poprzedniego
    Reset Flaga1
    If P = 1 Then
      P = 2
    Else
      P = 1
    End If
  End If
End Sub

Zalacz:                                                     'Przerwanie obslugi przycisku nowej gry
  Set Flaga3                                                'Flaga3 okresla rozpoczecie nowej gry
  Waitms 250
  Licznik = 0
  Bitwait Pind.2 , Set                                      'Czekaj na puszczenie przycisku
Return